import _fs = require("fs");
const fs: typeof _fs = nodeRequire("fs");
/**
 * 客户端前缀
 */
const clientPrefix = "const enum ServiceName {\n\t";

/**
 * 用于创建服务名字的常量文件
 */
export default class ServiceNameTemplate 
{
    public addToFile(file: string, serviceName: string) 
    {
        let valueDic: string[] = [];
        if (!fs.existsSync(file) || !fs.statSync(file).isFile()) {
            valueDic = ["$ = 0",serviceName];
            return this.addContent(serviceName, valueDic);
        }
        let temp = fs.readFileSync(file, "utf8");
        let content = temp;
        content = content.substring(clientPrefix.length, content.lastIndexOf("}"));
        content = content.replace(/\r\t/g, "").replace(/\n/g, "").replace(/\t/g, "").replace(/\r/g, "");
        valueDic = content.split(",");
        console.log("valueDic", valueDic);
        if (valueDic.indexOf(serviceName) == -1){
            valueDic.push(serviceName);
            return this.addContent(serviceName, valueDic);
        }
        return temp;
    }

    private addContent(serviceName: string, valueDic: string[]) {
        let added = false;
        let code = clientPrefix;
        //附加字典中的内容
        valueDic.sort((a: string, b: string)=>{
            let l = a.length > b.length ? b.length: a.length;
            if (a.charAt(0) == "$") return -1;
            if (b.charAt(0) == "$") return  1;
            for (let i = 0; i < l; i++)
            {
                let ai = a.charAt(i).toLocaleLowerCase().charCodeAt(0);
                let bi = b.charAt(i).toLocaleLowerCase().charCodeAt(0);
                if (ai > bi) return 1;
                else if (ai < bi) return -1;
            }
            return l == a.length ? -1 : 1;
        });
        code += valueDic.join(",\r\t");
        code += "\n}";
        console.log("code=====", code);
        return code;
    }
}